<template>
  <q-page class="flex-center">
    <div />
    <q-card>
      <q-bar class="bg-white">
        <q-btn
          push
          icon="save"
          @click="Create()"
          v-show="permissions.includes('add_provider')"
        >
          Save
          <q-tooltip>Save</q-tooltip>
        </q-btn>
        <q-btn push icon="cancel">
          Cancel
          <q-tooltip>Cancel</q-tooltip>
        </q-btn>
        <q-btn dense push icon="next_plan" @click="backPage">
          Back Page
          <q-tooltip>Back Page</q-tooltip>
        </q-btn>
      </q-bar>
      <q-card-section>
        <el-form
          :model="form"
          :rules="rules"
          ref="form"
          label-width="180px"
          class="demo-ruleForm"
        >
          <el-form-item label="Name" prop="name">
            <el-input v-model="form.name"></el-input>
          </el-form-item>
          <el-form-item label="Code" prop="code">
            <el-input v-model="form.code"></el-input>
          </el-form-item>
          <el-form-item label="Type Game" prop="type">
            <q-select
              filled
              label="Select Type Game"
              v-model="form.type"
              :options="type_options"
              option-value="value"
              option-label="label"
              option-disable="inactive"
              emit-value
              map-options
              v-show="sessionTypeGame.includes('view_type')"
            />
          </el-form-item>
          <el-form-item label="Percent" prop="percent">
            <el-input-number
              v-model="form.percent"
              controls-position="right"
              :min="0"
              :max="100"
            ></el-input-number>
          </el-form-item>
          <el-form-item label="Commission" prop="commission">
            <el-input-number
              v-model="form.commission"
              controls-position="right"
              :min="0"
              :max="100"
            ></el-input-number>
          </el-form-item>
        </el-form>
      </q-card-section>
      <hr />
      <q-table
        :rows-per-page-options="[15, 25, 50]"
        :data="form.game"
        :columns="columns"
        separator="cell"
        :filter="filter"
        :pagination.sync="pagination"
        row-key="id"
        v-show="sessionGame.includes('view_game')"
      >
        <template slot="top" slot-scope="props">
          <q-btn push rounded color="primary" icon="add" @click="add()"
            >Add Game
          </q-btn>
        </template>
        <q-tr slot="body" slot-scope="props" :props="props">
          <q-td
            key="No"
            :props="props"
            :style="{ width: '20px', whiteSpace: 'normal' }"
            >{{ props.row.No }}</q-td
          >
          <q-td
            key="name"
            :props="props"
            :style="{ width: '200px', whiteSpace: 'normal' }"
            >{{ props.row.name }}</q-td
          >
          <q-td
            key="code"
            :props="props"
            :style="{ width: '50px', whiteSpace: 'normal' }"
            >{{ props.row.code }}</q-td
          >
          <q-td
            key="type_id"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
            >{{ getNameType(props.row.type_id) }}</q-td
          >
          <q-td
            key="percent"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
            >{{ props.row.percent }}</q-td
          >
          <q-td
            key="commission"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
            >{{ props.row.commission }}</q-td
          >
          <q-td
            key="image"
            :props="props"
            :style="{ width: '200px', whiteSpace: 'normal' }"
          >
            <template>
              <img :src="ConvertImage(props.row.image)" class="image" />
            </template>
          </q-td>
          <q-td
            key="status"
            :props="props"
            :style="{ width: '20px', whiteSpace: 'normal' }"
          >
            <q-btn
              size="sm"
              :color="btn[props.row.status].color"
              :label="btn[props.row.status].label"
              class="q-mr-sm"
              @click="ChangeStatus(props.row)"
              v-show="sessionGame.includes('change_game')"
            />
          </q-td>
          <q-td
            key="action"
            :props="props"
            :style="{ width: '20px', whiteSpace: 'normal' }"
          >
            <div class="row items-center justify-between no-wrap">
              <q-btn
                size="sm"
                round
                rounded
                color="negative"
                icon="update"
                @click="loadgeme(props.row)"
                class="q-mr-xs"
                v-show="sessionGame.includes('change_game')"
              />
            </div>
          </q-td>
        </q-tr>
      </q-table>
    </q-card>
    <!-- add game -->
    <q-dialog
      v-model="modal_add"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_game"
            ref="form_game"
            :rules="rules_game"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Name" prop="name">
              <el-input v-model="form_game.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Code" prop="code">
              <el-input v-model="form_game.code" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Type Game" prop="type_id">
              <q-select
                filled
                label="Select Type Game"
                v-model="form_game.type_id"
                :options="type_options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                v-show="sessionTypeGame.includes('view_type')"
              />
            </el-form-item>
            <el-form-item label="Image" prop="image">
              <input
                type="file"
                id="file"
                ref="file"
                v-on:change="uploadImage"
              />
            </el-form-item>
            <el-form-item>
              <img v-bind:src="`data:image/png;base64,${form_game.image}`" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn
            push
            rounded
            color="primary"
            @click="insert()"
            v-show="sessionGame.includes('add_game')"
            >Submit</q-btn
          >
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- update game -->
    <q-dialog
      v-model="modal_edit"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="edit_game"
            ref="edit_game"
            :rules="rules_game_edit"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Name" prop="name">
              <el-input v-model="edit_game.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Code" prop="code">
              <el-input v-model="edit_game.code" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Type Game" prop="type_id">
              <q-select
                filled
                label="Select Type Game"
                v-model="edit_game.type_id"
                :options="type_options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                v-show="sessionTypeGame.includes('view_type')"
              />
            </el-form-item>
            <el-form-item label="Image" prop="image">
              <input
                type="file"
                id="file"
                ref="file"
                v-on:change="uploadImageEdit"
              />
            </el-form-item>
            <el-form-item>
              <img :src="ConvertImage(edit_game.image)" class="image" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn
            push
            rounded
            color="primary"
            @click="UpdateGame()"
            v-show="sessionGame.includes('change_game')"
            >Submit</q-btn
          >
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
// import 'bootstrap/dist/css/bootstrap.css'
// import 'bootstrap-vue/dist/bootstrap-vue.css'
export default {
  name: "ProviderAdd",
  data() {
    return {
      percent: 0,
      commission: 0,
      search: "",
      modal_add: false,
      modal_edit: false,
      options: [
        { value: 1, label: "Enable" },
        { value: 0, label: "Disable" }
      ],
      type_options: [],
      columns: [
        {
          name: "No",
          label: "No",
          field: "No",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "code",
          label: "Code",
          field: "code",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "type_id",
          label: "Type",
          field: "type_id",
          require: true,
          align: "left",
          stortable: true
        },
        // { name: 'percent', label: 'Percent', field: 'type_id', require: true, align: 'left', stortable: true },
        // { name: 'commission', label: 'Commission', field: 'type_id', require: true, align: 'left', stortable: true },
        {
          name: "image",
          label: "Image ",
          field: "image",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status",
          label: "Status",
          field: "status",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      filter: "",
      separator: "horizontal",
      pagination: {
        sortBy: null,
        descending: false,
        page: 1,
        rowsPerPage: 10
      },
      form: {
        name: "",
        code: "",
        type: "",
        percent: 0,
        commission: 0,
        game: []
      },
      form_game: {
        name: "",
        code: "",
        type_id: "",
        // percent: 0,
        // commission: 0,
        image: null
      },
      edit_game: {},
      rules: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        code: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        percent: [
          { required: true, message: "Please input percent", trigger: "blur" }
        ],
        type: [
          {
            required: true,
            message: "Please select type game",
            trigger: "change"
          }
        ]
      },
      rules_game: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        code: [
          { required: true, message: "Please input code", trigger: "blur" }
        ],
        type_id: [
          {
            required: true,
            message: "Please select type game",
            trigger: "change"
          }
        ],
        image: [
          { required: true, message: "Please select image", trigger: "change" }
        ]
        // percent:[{required: true, message: 'Please input percent', trigger: 'blur'}],
        // commission: [{required: true, message: 'Please input commission', trigger: 'blur'}]
      },
      rules_game_edit: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        code: [
          { required: true, message: "Please input code", trigger: "blur" }
        ],
        type_id: [
          {
            required: true,
            message: "Please select type game",
            trigger: "change"
          }
        ]
        // percent:[{required: true, message: 'Please input percent', trigger: 'blur'}],
        // commission: [{required: true, message: 'Please input commission', trigger: 'blur'}]
      },
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      permissions:
        this.$q.sessionStorage.getItem("permissions")["provider"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["provider"]
          : [],
      sessionGame:
        this.$q.sessionStorage.getItem("permissions")["game"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["game"]
          : [],
      sessionTypeGame:
        this.$q.sessionStorage.getItem("permissions")["type"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["type"]
          : []
    };
  },

  async created() {
    await this.getdata(this.$route.params.id);
    await this.gettypegame();
  },

  methods: {
    async getdata(params) {
      try {
        if (params) {
          const {
            id,
            name,
            status,
            code,
            type,
            percent,
            commission
          } = await this.$services.provider.find_by_id(params);
          this.form.id = id;
          this.form.name = name;
          this.form.code = code;
          this.form.status = status;
          this.form.type = type;
          this.form.percent = percent;
          this.form.commission = commission;
          this.form.game = await this.$services.provider.find_game_by_provider(
            params
          );
          this.$services.updateindex(this.form.game);
        }
      } catch (e) {
        this.$services.error(e.response);
      }
    },

    async gettypegame() {
      let ctx = this;
      this.$services.typegame
        .read({})
        .then(function(data) {
          data.forEach(row => {
            ctx.type_options.push({ value: row.id, label: row.name });
          });
        })
        .catch(function(e) {
          ctx.$services.error(e.response);
        });
    },

    add() {
      if (this.sessionGame.includes("add_game")) {
        this.$data.modal_add = true;
        this.$data.form_game = {
          name: "",
          code: "",
          type_id: "",
          image: null,
          game: []
        };
      }
    },

    async Create() {
      let ctx = this;
      this.$refs.form.validate(valid => {
        if (valid) {
          if (this.$route.params.id) {
            this.$services.provider
              .update(this.form, this.form.id)
              .then(function(data) {
                ctx.$services.success("Update Provider and Game Success");
                ctx.getdata(ctx.form.id);
              })
              .catch(function(e) {
                ctx.$services.error(e.response);
              });
          } else {
            this.$services.provider
              .add(this.$data.form)
              .then(function(data) {
                ctx.$services.success("Save Provider and Game Success");
                if (ctx.$route.name != "provideredit") {
                  ctx.$router.push({
                    name: "provideredit",
                    params: { id: data.data }
                  });
                }
                ctx.getdata(data.data);
              })
              .catch(function(e) {
                ctx.$services.error(e.response);
              });
          }
        }
      });
    },

    cancel() {
      // console.log('Cancel')
    },

    backPage() {
      this.$router.push({ name: "provider" });
    },

    uploadImage(e) {
      const image = e.target.files[0];
      const reader = new FileReader();
      reader.readAsDataURL(image);
      reader.onload = e => {
        this.form_game.image = e.target.result.split(",")[1];
      };
    },

    uploadImageEdit(e) {
      const image = e.target.files[0];
      const reader = new FileReader();
      reader.readAsDataURL(image);
      reader.onload = e => {
        this.edit_game.image = e.target.result.split(",")[1];
      };
    },

    async insert() {
      this.$refs.form_game.validate(valid => {
        if (valid) {
          this.form.game.push({
            name: this.form_game.name,
            code: this.form_game.code,
            type_id: this.form_game.type_id,
            status: 1,
            image: this.form_game.image
          });
          this.$services.updateindex(this.form.game);
          this.modal_add = false;
        }
      });
    },

    loadgeme(row) {
      this.edit_game = row;
      this.modal_edit = true;
    },

    UpdateGame() {
      let ctx = this;
      this.$refs.edit_game.validate(valid => {
        if (valid) {
          if (Object.keys(this.edit_game).includes("id")) {
            this.$services.provider
              .update_game(this.edit_game, this.edit_game.id)
              .then(function(data) {
                ctx.$services.success("Update Provider and Game Success");
              })
              .catch(function(e) {
                ctx.$services.error(e.response);
              });
          } else {
            let index = this.form.game.findIndex(
              x => x.No === this.edit_game.No
            );
            this.form.game[index]["name"] = this.edit_game.name;
            this.form.game[index]["code"] = this.edit_game.code;
            this.form.game[index]["type_id"] = this.edit_game.type_id;
            this.form.game[index]["image"] = this.edit_game.image;
          }
          this.modal_edit = false;
        }
      });
    },

    ConvertImage(image) {
      if (image != "") {
        if (/(http(s?)):\/\//i.test(image)) {
          return image;
        } else {
          return `data:image/png;base64,${image}`;
        }
      } else {
        return "";
      }
    },

    getNameType(value) {
      let name = "";
      this.type_options.forEach(row => {
        if (row.value === value) {
          name = row.label;
        }
      });

      return name;
    },

    ChangeStatus(row) {
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Game ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          if (row.status == 1) {
            row.status = 0;
          } else {
            row.status = 1;
          }
          this.$services.provider
            .update_game(row, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Game Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response);
            });
        })
        .onCancel(() => {
          // console.log(">>>> Cancel");
        });
    }
  }
};
</script>

<style lang="stylus"></style>
<style type="text/css">
img {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 100%;
}

.image {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 50%;
}
</style>
